//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: 21 December 1997
// Last Modified: Fri Jan 23 10:21:25 GMT-0800 1998
// Filename:      .../sig/code/control/MidiPort/MidiPort.h
// Syntax:        C++
// $Smake:        cc -Wall -g -c %b.cc -I../../../include && rm -f %b.o
//
// Description: A unified object that handles MIDI input and output.
//

#ifndef _MIDIPORT_H_INCLUDED
#define _MIDIPORT_H_INCLUDED


#include "MidiInPort.h"
#include "MidiOutPort.h"


class MidiPort : public MidiOutPort, public MidiInPort {
   public:
                 MidiPort            (void);
                 MidiPort            (int outputPort, int inputPort);
                ~MidiPort            ();

      int        getChannelInOffset  (void) const;
      int        getChannelOutOffset (void) const;
      int        getInputPort        (void);
      int        getInputTrace       (void);
      int        getOutputPort       (void);
      int        getOutputTrace      (void);
      void       setChannelOffset    (int anOffset);
      void       setInputPort        (int aPort);
      int        setInputTrace       (int aState);
      void       setOutputPort       (int aPort);
      int        setOutputTrace      (int aState);
      void       toggleInputTrace    (void);
      void       toggleOutputTrace   (void);

};



#endif  // _MIDIPORT_H_INCLUDED



